diff -Naur WebKit-r41128/debian/files WebKit-r41128-nx/debian/files
--- WebKit-r41128/debian/files	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/debian/files	2009-02-26 02:36:03.061010270 -0500
@@ -0,0 +1,3 @@
+libwebkit-dev_1.0-svn41128-1_all.deb libdevel extra
+libwebkit-1.0-1_1.0-svn41128-1_armel.deb user/other optional
+libwebkit-1.0-1-dbg_1.0-svn41128-1_armel.deb libdevel extra
diff -Naur WebKit-r41128/debian/libwebkit-1.0-1.install WebKit-r41128-nx/debian/libwebkit-1.0-1.install
--- WebKit-r41128/debian/libwebkit-1.0-1.install	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/debian/libwebkit-1.0-1.install	2009-02-23 16:01:26.257006910 -0500
@@ -0,0 +1,4 @@
+usr/lib/libwebkit-1.0.so.*
+usr/lib/webkit-1.0/libexec/GtkLauncher
+usr/lib/webkit-1.0/libexec/DumpRenderTree
+usr/share/webkit-1.0/*
diff -Naur WebKit-r41128/debian/libwebkit-dev.install WebKit-r41128-nx/debian/libwebkit-dev.install
--- WebKit-r41128/debian/libwebkit-dev.install	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/debian/libwebkit-dev.install	2009-02-23 16:01:26.290663510 -0500
@@ -0,0 +1,3 @@
+usr/lib/libwebkit-1.0.so
+usr/include/webkit-1.0
+usr/lib/pkgconfig/webkit-1.0.pc
diff -Naur WebKit-r41128/debian/rules WebKit-r41128-nx/debian/rules
--- WebKit-r41128/debian/rules	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/debian/rules	2009-02-23 16:01:26.324007030 -0500
@@ -0,0 +1,100 @@
+#!/usr/bin/make -f
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+
+export LC_ALL=en_US
+
+CFLAGS = -g -Wall
+
+ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
+        CFLAGS += -O2 -mfpu=vfp -mfloat-abi=softfp
+else
+        CFLAGS += -O0
+endif
+
+ifeq ($(DEB_BUILD_ARCH),alpha)
+        CFLAGS += -Wl,--no-relax
+endif
+
+clean:
+	dh_testdir
+	dh_testroot
+
+	rm -f build-stamp install-stamp
+	rm -rf build
+
+	rm -f GNUmakefile.in INSTALL README aclocal.m4 aconfig.h.in compile config.guess config.sub configure depcomp install-sh ltmain.sh missing
+	rm -rf autom4te.cache
+
+	dh_clean
+
+build: build-stamp
+
+build-stamp:
+	dh_testdir
+
+#	CPPFLAGS="-DMOBILE=1"
+	[ ! -d build ] && mkdir build || true
+	cd build && \
+	CFLAGS="$(CFLAGS)" \
+	CXXFLAGS="$(CFLAGS)" \
+	CC="gcc -Wl,--as-needed" \
+	CXX="g++ -Wl,--as-needed" \
+	../autogen.sh --prefix=/usr --with-hildon --with-unicode-backend=glib --disable-dashboard-support --enable-optimizations --enable-workers --with-http-backend=curl
+
+	$(MAKE) -j3 -C build
+
+	touch $@
+
+install: install-stamp
+
+install-stamp: build-stamp
+	dh_testdir
+	dh_testroot
+
+	dh_clean -k
+
+	$(MAKE) -j3 -C build install DESTDIR="$(CURDIR)"/debian/tmp
+	[ ! -d debian/tmp/usr/lib/webkit-1.0/libexec ] && install -d -m 755 debian/tmp/usr/lib/webkit-1.0/libexec || true
+	build/libtool --mode=install install -m 755 build/Programs/DumpRenderTree "$(CURDIR)"/debian/tmp/usr/lib/webkit-1.0/libexec/DumpRenderTree
+	build/libtool --mode=install install -m 755 build/Programs/GtkLauncher "$(CURDIR)"/debian/tmp/usr/lib/webkit-1.0/libexec/GtkLauncher
+
+	touch $@
+
+# Build architecture-independent files here.
+binary-indep: build install
+	dh_testdir
+	dh_testroot
+	dh_installdocs -i
+	dh_installchangelogs -i
+	dh_install -i --sourcedir=debian/tmp
+	dh_link -i
+	dh_compress -i
+	dh_fixperms -i
+	dh_installdeb -i
+	dh_gencontrol -i
+	dh_md5sums -i
+	dh_builddeb -i
+
+# Build architecture-dependent files here.
+binary-arch: build install
+	dh_testdir
+	dh_testroot
+	dh_installdocs -a
+	dh_installchangelogs -a
+	dh_install -a --sourcedir=debian/tmp
+	dh_link -a
+	dh_strip -a --dbg-package=libwebkit-1.0-1-dbg
+	dh_compress -a
+	dh_fixperms -a
+	dh_makeshlibs -a -V 'libwebkit-1.0-1 (>= 1.0.1)' -- -c4
+	dh_installdeb -a
+	dh_shlibdeps -a
+	dh_gencontrol -a
+	dh_md5sums -a
+	dh_builddeb -a
+
+binary: binary-indep binary-arch
+
+.PHONY: build clean install binary binary-indep binary-arch
diff -Naur WebKit-r41128/debian/shlibs.local WebKit-r41128-nx/debian/shlibs.local
--- WebKit-r41128/debian/shlibs.local	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/debian/shlibs.local	2009-02-23 16:01:26.357006550 -0500
@@ -0,0 +1,2 @@
+libglib-2.0 0 libglib2.0-0 (>= 2.12)
+libfreetype 6 libfreetype6 (>= 2.2)
diff -Naur WebKit-r41128/GNUmakefile.am WebKit-r41128-nx/GNUmakefile.am
--- WebKit-r41128/GNUmakefile.am	2009-02-20 22:38:12.000000000 -0500
+++ WebKit-r41128-nx/GNUmakefile.am	2009-02-23 16:01:26.392005430 -0500
@@ -50,8 +50,15 @@
 # Global flags to CPP
 global_cppflags :=
 
+if USE_ICU_UNICODE
 global_cppflags += \
 	-DWTF_USE_ICU_UNICODE=1
+endif
+
+if USE_GLIB_UNICODE
+global_cppflags += \
+	-DWTF_USE_GLIB_UNICODE=1
+endif
 
 # Default compiler flags
 global_cflags := \
@@ -314,6 +321,7 @@
 	WebKit/gtk/webkit/webkitwebpolicydecision.h \
 	WebKit/gtk/webkit/webkitwebsettings.h \
 	WebKit/gtk/webkit/webkitwebwindowfeatures.h \
+	WebKit/gtk/webkit/webkitwebdownload.h \
 	WebKit/gtk/webkit/webkitwebview.h
 
 webkitgtk_built_sources += \
@@ -348,6 +356,7 @@
 	WebKit/gtk/webkit/webkitwebnavigationaction.cpp \
 	WebKit/gtk/webkit/webkitwebpolicydecision.cpp \
 	WebKit/gtk/webkit/webkitwebsettings.cpp \
+	WebKit/gtk/webkit/webkitwebdownload.cpp \
 	WebKit/gtk/webkit/webkitwebview.cpp \
 	WebKit/gtk/webkit/webkitwebwindowfeatures.cpp
 
diff -Naur WebKit-r41128/JavaScriptCore/wtf/unicode/glib/CasefoldTableFromGLib.h WebKit-r41128-nx/JavaScriptCore/wtf/unicode/glib/CasefoldTableFromGLib.h
--- WebKit-r41128/JavaScriptCore/wtf/unicode/glib/CasefoldTableFromGLib.h	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/JavaScriptCore/wtf/unicode/glib/CasefoldTableFromGLib.h	2009-02-23 16:01:26.416357830 -0500
@@ -0,0 +1,200 @@
+/*
+ *  Copyright (C) 2006 George Staikos <staikos@kde.org>
+ *  Copyright (C) 2006 Alexey Proskuryakov <ap@nypop.com>
+ *  Copyright (C) 2007 Apple Computer, Inc. All rights reserved.
+ *  Copyright (C) 2008 Jürg Billeter <j@bitron.ch>
+ *  Copyright (C) 2008 Dominik Röttsches <dominik.roettsches@access-company.com>
+ *
+ *  This library is free software; you can redistribute it and/or
+ *  modify it under the terms of the GNU Library General Public
+ *  License as published by the Free Software Foundation; either
+ *  version 2 of the License, or (at your option) any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Library General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Library General Public License
+ *  along with this library; see the file COPYING.LIB.  If not, write to
+ *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ *
+ */
+
+#ifndef CasefoldTableFromGLib_h
+#define CasefoldTableFromGLib_h
+
+#include <glib.h>
+
+// copied from GLib
+
+/* Table of casefolding cases that can't be derived by lowercasing
+ */
+static const struct {
+    guint16 ch;
+    gchar data[7];
+} casefold_table[] = {
+    { 0x00b5, "\xce\xbc" },
+    { 0x00df, "\x73\x73" },
+    { 0x0130, "\x69\xcc\x87" },
+    { 0x0149, "\xca\xbc\x6e" },
+    { 0x017f, "\x73" },
+    { 0x01f0, "\x6a\xcc\x8c" },
+    { 0x0345, "\xce\xb9" },
+    { 0x0390, "\xce\xb9\xcc\x88\xcc\x81" },
+    { 0x03b0, "\xcf\x85\xcc\x88\xcc\x81" },
+    { 0x03c2, "\xcf\x83" },
+    { 0x03d0, "\xce\xb2" },
+    { 0x03d1, "\xce\xb8" },
+    { 0x03d5, "\xcf\x86" },
+    { 0x03d6, "\xcf\x80" },
+    { 0x03f0, "\xce\xba" },
+    { 0x03f1, "\xcf\x81" },
+    { 0x03f5, "\xce\xb5" },
+    { 0x0587, "\xd5\xa5\xd6\x82" },
+    { 0x1e96, "\x68\xcc\xb1" },
+    { 0x1e97, "\x74\xcc\x88" },
+    { 0x1e98, "\x77\xcc\x8a" },
+    { 0x1e99, "\x79\xcc\x8a" },
+    { 0x1e9a, "\x61\xca\xbe" },
+    { 0x1e9b, "\xe1\xb9\xa1" },
+    { 0x1f50, "\xcf\x85\xcc\x93" },
+    { 0x1f52, "\xcf\x85\xcc\x93\xcc\x80" },
+    { 0x1f54, "\xcf\x85\xcc\x93\xcc\x81" },
+    { 0x1f56, "\xcf\x85\xcc\x93\xcd\x82" },
+    { 0x1f80, "\xe1\xbc\x80\xce\xb9" },
+    { 0x1f81, "\xe1\xbc\x81\xce\xb9" },
+    { 0x1f82, "\xe1\xbc\x82\xce\xb9" },
+    { 0x1f83, "\xe1\xbc\x83\xce\xb9" },
+    { 0x1f84, "\xe1\xbc\x84\xce\xb9" },
+    { 0x1f85, "\xe1\xbc\x85\xce\xb9" },
+    { 0x1f86, "\xe1\xbc\x86\xce\xb9" },
+    { 0x1f87, "\xe1\xbc\x87\xce\xb9" },
+    { 0x1f88, "\xe1\xbc\x80\xce\xb9" },
+    { 0x1f89, "\xe1\xbc\x81\xce\xb9" },
+    { 0x1f8a, "\xe1\xbc\x82\xce\xb9" },
+    { 0x1f8b, "\xe1\xbc\x83\xce\xb9" },
+    { 0x1f8c, "\xe1\xbc\x84\xce\xb9" },
+    { 0x1f8d, "\xe1\xbc\x85\xce\xb9" },
+    { 0x1f8e, "\xe1\xbc\x86\xce\xb9" },
+    { 0x1f8f, "\xe1\xbc\x87\xce\xb9" },
+    { 0x1f90, "\xe1\xbc\xa0\xce\xb9" },
+    { 0x1f91, "\xe1\xbc\xa1\xce\xb9" },
+    { 0x1f92, "\xe1\xbc\xa2\xce\xb9" },
+    { 0x1f93, "\xe1\xbc\xa3\xce\xb9" },
+    { 0x1f94, "\xe1\xbc\xa4\xce\xb9" },
+    { 0x1f95, "\xe1\xbc\xa5\xce\xb9" },
+    { 0x1f96, "\xe1\xbc\xa6\xce\xb9" },
+    { 0x1f97, "\xe1\xbc\xa7\xce\xb9" },
+    { 0x1f98, "\xe1\xbc\xa0\xce\xb9" },
+    { 0x1f99, "\xe1\xbc\xa1\xce\xb9" },
+    { 0x1f9a, "\xe1\xbc\xa2\xce\xb9" },
+    { 0x1f9b, "\xe1\xbc\xa3\xce\xb9" },
+    { 0x1f9c, "\xe1\xbc\xa4\xce\xb9" },
+    { 0x1f9d, "\xe1\xbc\xa5\xce\xb9" },
+    { 0x1f9e, "\xe1\xbc\xa6\xce\xb9" },
+    { 0x1f9f, "\xe1\xbc\xa7\xce\xb9" },
+    { 0x1fa0, "\xe1\xbd\xa0\xce\xb9" },
+    { 0x1fa1, "\xe1\xbd\xa1\xce\xb9" },
+    { 0x1fa2, "\xe1\xbd\xa2\xce\xb9" },
+    { 0x1fa3, "\xe1\xbd\xa3\xce\xb9" },
+    { 0x1fa4, "\xe1\xbd\xa4\xce\xb9" },
+    { 0x1fa5, "\xe1\xbd\xa5\xce\xb9" },
+    { 0x1fa6, "\xe1\xbd\xa6\xce\xb9" },
+    { 0x1fa7, "\xe1\xbd\xa7\xce\xb9" },
+    { 0x1fa8, "\xe1\xbd\xa0\xce\xb9" },
+    { 0x1fa9, "\xe1\xbd\xa1\xce\xb9" },
+    { 0x1faa, "\xe1\xbd\xa2\xce\xb9" },
+    { 0x1fab, "\xe1\xbd\xa3\xce\xb9" },
+    { 0x1fac, "\xe1\xbd\xa4\xce\xb9" },
+    { 0x1fad, "\xe1\xbd\xa5\xce\xb9" },
+    { 0x1fae, "\xe1\xbd\xa6\xce\xb9" },
+    { 0x1faf, "\xe1\xbd\xa7\xce\xb9" },
+    { 0x1fb2, "\xe1\xbd\xb0\xce\xb9" },
+    { 0x1fb3, "\xce\xb1\xce\xb9" },
+    { 0x1fb4, "\xce\xac\xce\xb9" },
+    { 0x1fb6, "\xce\xb1\xcd\x82" },
+    { 0x1fb7, "\xce\xb1\xcd\x82\xce\xb9" },
+    { 0x1fbc, "\xce\xb1\xce\xb9" },
+    { 0x1fbe, "\xce\xb9" },
+    { 0x1fc2, "\xe1\xbd\xb4\xce\xb9" },
+    { 0x1fc3, "\xce\xb7\xce\xb9" },
+    { 0x1fc4, "\xce\xae\xce\xb9" },
+    { 0x1fc6, "\xce\xb7\xcd\x82" },
+    { 0x1fc7, "\xce\xb7\xcd\x82\xce\xb9" },
+    { 0x1fcc, "\xce\xb7\xce\xb9" },
+    { 0x1fd2, "\xce\xb9\xcc\x88\xcc\x80" },
+    { 0x1fd3, "\xce\xb9\xcc\x88\xcc\x81" },
+    { 0x1fd6, "\xce\xb9\xcd\x82" },
+    { 0x1fd7, "\xce\xb9\xcc\x88\xcd\x82" },
+    { 0x1fe2, "\xcf\x85\xcc\x88\xcc\x80" },
+    { 0x1fe3, "\xcf\x85\xcc\x88\xcc\x81" },
+    { 0x1fe4, "\xcf\x81\xcc\x93" },
+    { 0x1fe6, "\xcf\x85\xcd\x82" },
+    { 0x1fe7, "\xcf\x85\xcc\x88\xcd\x82" },
+    { 0x1ff2, "\xe1\xbd\xbc\xce\xb9" },
+    { 0x1ff3, "\xcf\x89\xce\xb9" },
+    { 0x1ff4, "\xcf\x8e\xce\xb9" },
+    { 0x1ff6, "\xcf\x89\xcd\x82" },
+    { 0x1ff7, "\xcf\x89\xcd\x82\xce\xb9" },
+    { 0x1ffc, "\xcf\x89\xce\xb9" },
+    { 0x2160, "\xe2\x85\xb0" },
+    { 0x2161, "\xe2\x85\xb1" },
+    { 0x2162, "\xe2\x85\xb2" },
+    { 0x2163, "\xe2\x85\xb3" },
+    { 0x2164, "\xe2\x85\xb4" },
+    { 0x2165, "\xe2\x85\xb5" },
+    { 0x2166, "\xe2\x85\xb6" },
+    { 0x2167, "\xe2\x85\xb7" },
+    { 0x2168, "\xe2\x85\xb8" },
+    { 0x2169, "\xe2\x85\xb9" },
+    { 0x216a, "\xe2\x85\xba" },
+    { 0x216b, "\xe2\x85\xbb" },
+    { 0x216c, "\xe2\x85\xbc" },
+    { 0x216d, "\xe2\x85\xbd" },
+    { 0x216e, "\xe2\x85\xbe" },
+    { 0x216f, "\xe2\x85\xbf" },
+    { 0x24b6, "\xe2\x93\x90" },
+    { 0x24b7, "\xe2\x93\x91" },
+    { 0x24b8, "\xe2\x93\x92" },
+    { 0x24b9, "\xe2\x93\x93" },
+    { 0x24ba, "\xe2\x93\x94" },
+    { 0x24bb, "\xe2\x93\x95" },
+    { 0x24bc, "\xe2\x93\x96" },
+    { 0x24bd, "\xe2\x93\x97" },
+    { 0x24be, "\xe2\x93\x98" },
+    { 0x24bf, "\xe2\x93\x99" },
+    { 0x24c0, "\xe2\x93\x9a" },
+    { 0x24c1, "\xe2\x93\x9b" },
+    { 0x24c2, "\xe2\x93\x9c" },
+    { 0x24c3, "\xe2\x93\x9d" },
+    { 0x24c4, "\xe2\x93\x9e" },
+    { 0x24c5, "\xe2\x93\x9f" },
+    { 0x24c6, "\xe2\x93\xa0" },
+    { 0x24c7, "\xe2\x93\xa1" },
+    { 0x24c8, "\xe2\x93\xa2" },
+    { 0x24c9, "\xe2\x93\xa3" },
+    { 0x24ca, "\xe2\x93\xa4" },
+    { 0x24cb, "\xe2\x93\xa5" },
+    { 0x24cc, "\xe2\x93\xa6" },
+    { 0x24cd, "\xe2\x93\xa7" },
+    { 0x24ce, "\xe2\x93\xa8" },
+    { 0x24cf, "\xe2\x93\xa9" },
+    { 0xfb00, "\x66\x66" },
+    { 0xfb01, "\x66\x69" },
+    { 0xfb02, "\x66\x6c" },
+    { 0xfb03, "\x66\x66\x69" },
+    { 0xfb04, "\x66\x66\x6c" },
+    { 0xfb05, "\x73\x74" },
+    { 0xfb06, "\x73\x74" },
+    { 0xfb13, "\xd5\xb4\xd5\xb6" },
+    { 0xfb14, "\xd5\xb4\xd5\xa5" },
+    { 0xfb15, "\xd5\xb4\xd5\xab" },
+    { 0xfb16, "\xd5\xbe\xd5\xb6" },
+    { 0xfb17, "\xd5\xb4\xd5\xad" }
+};
+
+
+#endif
+
diff -Naur WebKit-r41128/JavaScriptCore/wtf/unicode/glib/UnicodeGLib.h WebKit-r41128-nx/JavaScriptCore/wtf/unicode/glib/UnicodeGLib.h
--- WebKit-r41128/JavaScriptCore/wtf/unicode/glib/UnicodeGLib.h	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/JavaScriptCore/wtf/unicode/glib/UnicodeGLib.h	2009-02-23 16:01:26.441006430 -0500
@@ -0,0 +1,407 @@
+/*
+ *  Copyright (C) 2006 George Staikos <staikos@kde.org>
+ *  Copyright (C) 2006 Alexey Proskuryakov <ap@nypop.com>
+ *  Copyright (C) 2007 Apple Computer, Inc. All rights reserved.
+ *  Copyright (C) 2008 Jürg Billeter <j@bitron.ch>
+ *  Copyright (C) 2008 Dominik Röttsches <dominik.roettsches@access-company.com>
+ *
+ *  This library is free software; you can redistribute it and/or
+ *  modify it under the terms of the GNU Library General Public
+ *  License as published by the Free Software Foundation; either
+ *  version 2 of the License, or (at your option) any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Library General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Library General Public License
+ *  along with this library; see the file COPYING.LIB.  If not, write to
+ *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ *
+ */
+
+#ifndef UnicodeGLib_h
+#define UnicodeGLib_h
+
+#include <stdlib.h>
+#include <stdint.h>
+#include <string.h>
+
+#include <glib.h>
+#include <pango/pango.h>
+
+#include <wtf/GOwnPtr.h>
+
+#include "CasefoldTableFromGLib.h"
+#include "UnicodeGLibTypes.h"
+#include "UnicodeMacrosFromICU.h"
+
+namespace WTF {
+    namespace Unicode {
+
+        enum Direction {
+            LeftToRight,
+            RightToLeft,
+            EuropeanNumber,
+            EuropeanNumberSeparator,
+            EuropeanNumberTerminator,
+            ArabicNumber,
+            CommonNumberSeparator,
+            BlockSeparator,
+            SegmentSeparator,
+            WhiteSpaceNeutral,
+            OtherNeutral,
+            LeftToRightEmbedding,
+            LeftToRightOverride,
+            RightToLeftArabic,
+            RightToLeftEmbedding,
+            RightToLeftOverride,
+            PopDirectionalFormat,
+            NonSpacingMark,
+            BoundaryNeutral
+        };
+
+        enum DecompositionType {
+            DecompositionNone,
+            DecompositionCanonical,
+            DecompositionCompat,
+            DecompositionCircle,
+            DecompositionFinal,
+            DecompositionFont,
+            DecompositionFraction,
+            DecompositionInitial,
+            DecompositionIsolated,
+            DecompositionMedial,
+            DecompositionNarrow,
+            DecompositionNoBreak,
+            DecompositionSmall,
+            DecompositionSquare,
+            DecompositionSub,
+            DecompositionSuper,
+            DecompositionVertical,
+            DecompositionWide,
+        };
+
+        enum CharCategory {
+            NoCategory =  0,
+            Other_NotAssigned = U_MASK(G_UNICODE_UNASSIGNED),
+            Letter_Uppercase = U_MASK(G_UNICODE_UPPERCASE_LETTER),
+            Letter_Lowercase = U_MASK(G_UNICODE_LOWERCASE_LETTER),
+            Letter_Titlecase = U_MASK(G_UNICODE_TITLECASE_LETTER),
+            Letter_Modifier = U_MASK(G_UNICODE_MODIFIER_LETTER),
+            Letter_Other = U_MASK(G_UNICODE_OTHER_LETTER),
+
+            Mark_NonSpacing = U_MASK(G_UNICODE_NON_SPACING_MARK),
+            Mark_Enclosing = U_MASK(G_UNICODE_ENCLOSING_MARK),
+            Mark_SpacingCombining = U_MASK(G_UNICODE_COMBINING_MARK),
+
+            Number_DecimalDigit = U_MASK(G_UNICODE_DECIMAL_NUMBER),
+            Number_Letter = U_MASK(G_UNICODE_LETTER_NUMBER),
+            Number_Other = U_MASK(G_UNICODE_OTHER_NUMBER),
+
+            Separator_Space = U_MASK(G_UNICODE_SPACE_SEPARATOR),
+            Separator_Line = U_MASK(G_UNICODE_LINE_SEPARATOR),
+            Separator_Paragraph = U_MASK(G_UNICODE_PARAGRAPH_SEPARATOR),
+
+            Other_Control = U_MASK(G_UNICODE_CONTROL),
+            Other_Format = U_MASK(G_UNICODE_FORMAT),
+            Other_PrivateUse = U_MASK(G_UNICODE_PRIVATE_USE),
+            Other_Surrogate = U_MASK(G_UNICODE_SURROGATE),
+
+            Punctuation_Dash = U_MASK(G_UNICODE_DASH_PUNCTUATION),
+            Punctuation_Open = U_MASK(G_UNICODE_OPEN_PUNCTUATION),
+            Punctuation_Close = U_MASK(G_UNICODE_CLOSE_PUNCTUATION),
+            Punctuation_Connector = U_MASK(G_UNICODE_CONNECT_PUNCTUATION),
+            Punctuation_Other = U_MASK(G_UNICODE_OTHER_PUNCTUATION),
+
+            Symbol_Math = U_MASK(G_UNICODE_MATH_SYMBOL),
+            Symbol_Currency = U_MASK(G_UNICODE_CURRENCY_SYMBOL),
+            Symbol_Modifier = U_MASK(G_UNICODE_MODIFIER_SYMBOL),
+            Symbol_Other = U_MASK(G_UNICODE_OTHER_SYMBOL),
+
+            Punctuation_InitialQuote = U_MASK(G_UNICODE_INITIAL_PUNCTUATION),
+            Punctuation_FinalQuote = U_MASK(G_UNICODE_FINAL_PUNCTUATION)
+        };
+
+        inline UChar32 foldCase(UChar32 ch)
+        {
+            // add g_unichar_casefold to GLib upstream?
+
+            int start = 0;
+            int end = G_N_ELEMENTS(casefold_table);
+
+            if (ch >= casefold_table[start].ch &&
+                ch <= casefold_table[end - 1].ch) {
+                while (true) {
+                    int half = (start + end) / 2;
+                    if (ch == casefold_table[half].ch)
+                        return g_utf8_get_char(casefold_table[half].data);
+                    if (half == start)
+                        break;
+                    else if (ch > casefold_table[half].ch)
+                        start = half;
+                    else
+                        end = half;
+                }
+            }
+
+            return g_unichar_tolower (ch);
+        }
+
+        inline int foldCase(UChar* result, int resultLength, const UChar* src, int srcLength, bool* error)
+        {
+            *error = false;
+            GOwnPtr<GError> gerror;
+
+            GOwnPtr<char> utf8src;
+            utf8src.set(g_utf16_to_utf8(src, srcLength, 0, 0, &gerror.outPtr()));
+            if (gerror) {
+                *error = true;
+                return -1;
+            }
+
+            GOwnPtr<char> utf8result;
+            utf8result.set(g_utf8_casefold(utf8src.get(), -1));
+
+            long utf16resultLength = -1;
+            GOwnPtr<UChar> utf16result;
+            utf16result.set(g_utf8_to_utf16(utf8result.get(), -1, 0, &utf16resultLength, &gerror.outPtr()));
+            if (gerror) {
+                *error = true;
+                return -1;
+            }
+
+            if (utf16resultLength > resultLength) {
+                *error = true;
+                return utf16resultLength;
+            }
+            memcpy(result, utf16result.get(), utf16resultLength * sizeof(UChar));
+
+            return utf16resultLength;
+        }
+
+        inline int toLower(UChar* result, int resultLength, const UChar* src, int srcLength, bool* error)
+        {
+            *error = false;
+            GOwnPtr<GError> gerror;
+
+            GOwnPtr<char> utf8src;
+            utf8src.set(g_utf16_to_utf8(src, srcLength, 0, 0, &gerror.outPtr()));
+            if (gerror) {
+                *error = true;
+                return -1;
+            }
+
+            GOwnPtr<char> utf8result;
+            utf8result.set(g_utf8_strdown(utf8src.get(), -1));
+
+            long utf16resultLength = -1;
+            GOwnPtr<UChar> utf16result;
+            utf16result.set(g_utf8_to_utf16(utf8result.get(), -1, 0, &utf16resultLength, &gerror.outPtr()));
+            if (gerror) {
+                *error = true;
+                return -1;
+            }
+
+            if (utf16resultLength > resultLength) {
+                *error = true;
+                return utf16resultLength;
+            }
+            memcpy(result, utf16result.get(), utf16resultLength * sizeof(UChar));
+
+            return utf16resultLength;
+        }
+
+        inline UChar32 toLower(UChar32 c)
+        {
+            return g_unichar_tolower(c);
+        }
+
+        inline UChar32 toUpper(UChar32 c)
+        {
+            return g_unichar_toupper(c);
+        }
+
+        inline int toUpper(UChar* result, int resultLength, const UChar* src, int srcLength, bool* error)
+        {
+            *error = false;
+            GOwnPtr<GError> gerror;
+
+            GOwnPtr<char> utf8src;
+            utf8src.set(g_utf16_to_utf8(src, srcLength, 0, 0, &gerror.outPtr()));
+            if (gerror) {
+                *error = true;
+                return -1;
+            }
+
+            GOwnPtr<char> utf8result;
+            utf8result.set(g_utf8_strup(utf8src.get(), -1));
+
+            long utf16resultLength = -1;
+            GOwnPtr<UChar> utf16result;
+            utf16result.set(g_utf8_to_utf16(utf8result.get(), -1, 0, &utf16resultLength, &gerror.outPtr()));
+            if (gerror) {
+                *error = true;
+                return -1;
+            }
+
+            if (utf16resultLength > resultLength) {
+                *error = true;
+                return utf16resultLength;
+            }
+            memcpy(result, utf16result.get(), utf16resultLength * sizeof(UChar));
+
+            return utf16resultLength;
+        }
+
+        inline UChar32 toTitleCase(UChar32 c)
+        {
+            return g_unichar_totitle(c);
+        }
+
+        inline bool isArabicChar(UChar32 c)
+        {
+            return c >= 0x0600 && c <= 0x06FF;
+        }
+
+        inline bool isFormatChar(UChar32 c)
+        {
+            return g_unichar_type(c) == G_UNICODE_FORMAT;
+        }
+
+        inline bool isSeparatorSpace(UChar32 c)
+        {
+            return g_unichar_type(c) == G_UNICODE_SPACE_SEPARATOR;
+        }
+
+        inline bool isPrintableChar(UChar32 c)
+        {
+            return g_unichar_isprint(c);
+        }
+    
+        inline bool isDigit(UChar32 c)
+        {
+            return g_unichar_isdigit(c);
+        }
+
+        inline bool isPunct(UChar32 c)
+        {
+            return g_unichar_ispunct(c);
+        }
+
+        inline UChar32 mirroredChar(UChar32 c)
+        {
+            gunichar mirror = 0;
+            g_unichar_get_mirror_char(c, &mirror);
+            return mirror;
+        }
+
+        inline CharCategory category(UChar32 c)
+        {
+            if (c > 0xffff)
+                return NoCategory;
+
+            return (CharCategory) U_MASK(g_unichar_type(c));
+        }
+
+        inline Direction direction(UChar32 c)
+        {
+            /*PangoBidiType*/ PangoDirection type = pango_unichar_direction(c);//pango_bidi_type_for_unichar(c);
+            switch (type) {
+        	case PANGO_DIRECTION_LTR:
+        	    return LeftToRight;
+        	case PANGO_DIRECTION_RTL:
+        	    return RightToLeft;
+        	case PANGO_DIRECTION_WEAK_LTR:
+        	    return EuropeanNumber;
+        	case PANGO_DIRECTION_WEAK_RTL:
+        	    return ArabicNumber;
+/*            case PANGO_BIDI_TYPE_L: 
+                return LeftToRight;
+            case PANGO_BIDI_TYPE_R: 
+                return RightToLeft;
+            case PANGO_BIDI_TYPE_AL:
+                return RightToLeftArabic;
+            case PANGO_BIDI_TYPE_LRE:
+                return LeftToRightEmbedding;
+            case PANGO_BIDI_TYPE_RLE:
+                return RightToLeftEmbedding;
+            case PANGO_BIDI_TYPE_LRO:
+                return LeftToRightOverride;
+            case PANGO_BIDI_TYPE_RLO:
+                return RightToLeftOverride;
+            case PANGO_BIDI_TYPE_PDF:
+                return PopDirectionalFormat;
+            case PANGO_BIDI_TYPE_EN:
+                return EuropeanNumber;
+            case PANGO_BIDI_TYPE_AN:
+                return ArabicNumber;
+            case PANGO_BIDI_TYPE_ES:
+                return EuropeanNumberSeparator;
+            case PANGO_BIDI_TYPE_ET:
+                return EuropeanNumberTerminator;
+            case PANGO_BIDI_TYPE_CS:
+                return CommonNumberSeparator;
+            case PANGO_BIDI_TYPE_NSM:
+                return NonSpacingMark;
+            case PANGO_BIDI_TYPE_BN:
+                return BoundaryNeutral;
+            case PANGO_BIDI_TYPE_B:
+                return BlockSeparator;
+            case PANGO_BIDI_TYPE_S:
+                return SegmentSeparator;
+            case PANGO_BIDI_TYPE_WS:
+                return WhiteSpaceNeutral;*/
+            default:
+                return OtherNeutral;
+            } 
+        }
+
+        inline bool isLower(UChar32 c)
+        {
+            return g_unichar_islower(c);
+        }
+
+        inline int digitValue(UChar32 c)
+        {
+            return g_unichar_digit_value(c);
+        }
+
+        inline uint8_t combiningClass(UChar32 c)
+        {
+            // return g_unichar_combining_class(c);
+            return 0;
+        }
+
+        inline DecompositionType decompositionType(UChar32 c)
+        {
+            // FIXME
+            return DecompositionNone;
+        }
+
+        inline int umemcasecmp(const UChar* a, const UChar* b, int len)
+        {
+            GOwnPtr<char> utf8a;
+            GOwnPtr<char> utf8b;
+
+            utf8a.set(g_utf16_to_utf8(a, len, 0, 0, 0));
+            utf8b.set(g_utf16_to_utf8(b, len, 0, 0, 0));
+
+            GOwnPtr<char> foldedA;
+            GOwnPtr<char> foldedB;
+
+            foldedA.set(g_utf8_casefold(utf8a.get(), -1));
+            foldedB.set(g_utf8_casefold(utf8b.get(), -1));
+
+            int result = g_utf8_collate(foldedA.get(), foldedB.get());
+
+            return result;
+        }
+
+    }
+}
+
+#endif
+
diff -Naur WebKit-r41128/JavaScriptCore/wtf/unicode/glib/UnicodeGLibTypes.h WebKit-r41128-nx/JavaScriptCore/wtf/unicode/glib/UnicodeGLibTypes.h
--- WebKit-r41128/JavaScriptCore/wtf/unicode/glib/UnicodeGLibTypes.h	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/JavaScriptCore/wtf/unicode/glib/UnicodeGLibTypes.h	2009-02-23 16:01:26.476005510 -0500
@@ -0,0 +1,31 @@
+/*
+ *  Copyright (C) 2006 George Staikos <staikos@kde.org>
+ *  Copyright (C) 2006 Alexey Proskuryakov <ap@nypop.com>
+ *  Copyright (C) 2007 Apple Computer, Inc. All rights reserved.
+ *  Copyright (C) 2008 Jürg Billeter <j@bitron.ch>
+ *  Copyright (C) 2008 Dominik Röttsches <dominik.roettsches@access-company.com>
+ *
+ *  This library is free software; you can redistribute it and/or
+ *  modify it under the terms of the GNU Library General Public
+ *  License as published by the Free Software Foundation; either
+ *  version 2 of the License, or (at your option) any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Library General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Library General Public License
+ *  along with this library; see the file COPYING.LIB.  If not, write to
+ *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ *
+ */
+
+#ifndef UnicodeGLibTypes_h
+#define UnicodeGLibTypes_h
+
+typedef uint16_t UChar;
+typedef int32_t UChar32;
+
+#endif
diff -Naur WebKit-r41128/JavaScriptCore/wtf/unicode/glib/UnicodeMacrosFromICU.h WebKit-r41128-nx/JavaScriptCore/wtf/unicode/glib/UnicodeMacrosFromICU.h
--- WebKit-r41128/JavaScriptCore/wtf/unicode/glib/UnicodeMacrosFromICU.h	1969-12-31 19:00:00.000000000 -0500
+++ WebKit-r41128-nx/JavaScriptCore/wtf/unicode/glib/UnicodeMacrosFromICU.h	2009-02-23 16:01:26.524007150 -0500
@@ -0,0 +1,58 @@
+/*
+ *  Copyright (C) 2006 George Staikos <staikos@kde.org>
+ *  Copyright (C) 2006 Alexey Proskuryakov <ap@nypop.com>
+ *  Copyright (C) 2007 Apple Computer, Inc. All rights reserved.
+ *  Copyright (C) 2008 Jürg Billeter <j@bitron.ch>
+ *  Copyright (C) 2008 Dominik Röttsches <dominik.roettsches@access-company.com>
+ *
+ *  This library is free software; you can redistribute it and/or
+ *  modify it under the terms of the GNU Library General Public
+ *  License as published by the Free Software Foundation; either
+ *  version 2 of the License, or (at your option) any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Library General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Library General Public License
+ *  along with this library; see the file COPYING.LIB.  If not, write to
+ *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ *
+ */
+
+#ifndef UnicodeMacrosFromICU_h
+#define UnicodeMacrosFromICU_h
+
+// some defines from ICU
+
+#define U16_IS_LEAD(c) (((c)&0xfffffc00)==0xd800)
+#define U16_IS_TRAIL(c) (((c)&0xfffffc00)==0xdc00)
+#define U16_SURROGATE_OFFSET ((0xd800<<10UL)+0xdc00-0x10000)
+#define U16_GET_SUPPLEMENTARY(lead, trail) \
+    (((UChar32)(lead)<<10UL)+(UChar32)(trail)-U16_SURROGATE_OFFSET)
+
+#define U16_LEAD(supplementary) (UChar)(((supplementary)>>10)+0xd7c0)
+#define U16_TRAIL(supplementary) (UChar)(((supplementary)&0x3ff)|0xdc00)
+
+#define U_IS_SURROGATE(c) (((c)&0xfffff800)==0xd800)
+#define U16_IS_SINGLE(c) !U_IS_SURROGATE(c)
+#define U16_IS_SURROGATE(c) U_IS_SURROGATE(c)
+#define U16_IS_SURROGATE_LEAD(c) (((c)&0x400)==0)
+
+#define U16_NEXT(s, i, length, c) { \
+    (c)=(s)[(i)++]; \
+    if(U16_IS_LEAD(c)) { \
+        uint16_t __c2; \
+        if((i)<(length) && U16_IS_TRAIL(__c2=(s)[(i)])) { \
+            ++(i); \
+            (c)=U16_GET_SUPPLEMENTARY((c), __c2); \
+        } \
+    } \
+}
+
+#define U_MASK(x) ((uint32_t)1<<(x))
+
+#endif
+
diff -Naur WebKit-r41128/JavaScriptCore/wtf/unicode/Unicode.h WebKit-r41128-nx/JavaScriptCore/wtf/unicode/Unicode.h
--- WebKit-r41128/JavaScriptCore/wtf/unicode/Unicode.h	2009-01-21 00:13:29.000000000 -0500
+++ WebKit-r41128-nx/JavaScriptCore/wtf/unicode/Unicode.h	2009-02-23 16:01:26.560005390 -0500
@@ -28,6 +28,8 @@
 #include "qt4/UnicodeQt4.h"
 #elif USE(ICU_UNICODE)
 #include <wtf/unicode/icu/UnicodeIcu.h>
+#elif USE(GLIB_UNICODE)
+#include <wtf/unicode/glib/UnicodeGLib.h>
 #else
 #error "Unknown Unicode implementation"
 #endif
diff -Naur WebKit-r41128/WebCore/bridge/IdentifierRep.h WebKit-r41128-nx/WebCore/bridge/IdentifierRep.h
--- WebKit-r41128/WebCore/bridge/IdentifierRep.h	2009-02-15 03:48:41.000000000 -0500
+++ WebKit-r41128-nx/WebCore/bridge/IdentifierRep.h	2009-02-23 16:01:26.584007270 -0500
@@ -26,6 +26,7 @@
 #ifndef IdentifierRep_h
 #define IdentifierRep_h
 
+#include <string.h>
 #include <wtf/Assertions.h>
 #include <string.h>
 
